Index: src/Actions/AtomAction/RemoveAction.hpp
===================================================================
--- src/Actions/AtomAction/RemoveAction.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/AtomAction/RemoveAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -11,5 +11,9 @@
 #include "Actions/Action.hpp"
 
+void AtomRemove();
+
 class AtomRemoveAction : public Action {
+  friend void AtomRemove();
+
 public:
   AtomRemoveAction();
@@ -20,4 +24,6 @@
 
   virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog*);
 private:
   virtual Action::state_ptr performCall();
Index: src/Actions/AtomAction/RotateAroundOriginByAngleAction.cpp
===================================================================
--- src/Actions/AtomAction/RotateAroundOriginByAngleAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Actions/AtomAction/RotateAroundOriginByAngleAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,138 @@
+/*
+ * RotateAroundOriginByAngleAction.cpp
+ *
+ *  Created on: Aug 06, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "Actions/AtomAction/RotateAroundOriginByAngleAction.hpp"
+#include "Actions/ActionRegistry.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "LinearAlgebra/Line.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "molecule.hpp"
+
+
+#include <iostream>
+#include <fstream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/ValueStorage.hpp"
+
+/****** AtomRotateAroundOriginByAngleAction *****/
+
+// memento to remember the state when undoing
+
+class AtomRotateAroundOriginByAngleState : public ActionState {
+public:
+  AtomRotateAroundOriginByAngleState(std::vector<atom*> _selectedAtoms, const Vector &_Axis, const double _alpha) :
+    selectedAtoms(_selectedAtoms),
+    Axis(_Axis),
+    alpha(_alpha)
+  {}
+  std::vector<atom*> selectedAtoms;
+  Vector Axis;
+  double alpha;
+};
+
+const char AtomRotateAroundOriginByAngleAction::NAME[] = "rotate-origin";
+
+AtomRotateAroundOriginByAngleAction::AtomRotateAroundOriginByAngleAction() :
+  Action(NAME)
+{}
+
+AtomRotateAroundOriginByAngleAction::~AtomRotateAroundOriginByAngleAction()
+{}
+
+void AtomRotateAroundOriginByAngle(const Vector &Axis, double angle) {
+  ValueStorage::getInstance().setCurrentValue(AtomRotateAroundOriginByAngleAction::NAME, angle);
+  ValueStorage::getInstance().setCurrentValue("position", Axis);
+  ActionRegistry::getInstance().getActionByName(AtomRotateAroundOriginByAngleAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* AtomRotateAroundOriginByAngleAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryDouble(NAME, ValueStorage::getInstance().getDescription(NAME));
+  dialog->queryVector("position", false, ValueStorage::getInstance().getDescription("position"));
+
+  return dialog;
+}
+
+Action::state_ptr AtomRotateAroundOriginByAngleAction::performCall() {
+  double alpha = 0.;
+  Vector Axis;
+  std::vector<atom *> selectedAtoms = World::getInstance().getSelectedAtoms();
+
+  // obtain axis to rotate to
+  ValueStorage::getInstance().queryCurrentValue(NAME, alpha);
+  ValueStorage::getInstance().queryCurrentValue("position", Axis);
+
+  // check whether Axis is valid
+  if (Axis.IsZero())
+    return Action::failure;
+
+  // convert from degrees to radian
+  alpha *= M_PI/180.;
+
+  // Creation Line that is the rotation axis
+  Line RotationAxis(Vector(0.,0.,0.), Axis);
+
+  DoLog(0) && (Log() << Verbose(0) << "Rotate around origin by " << alpha << " radian, axis from origin to " << Axis << "." << endl);
+  // TODO: use AtomSet::rotate?
+  for (std::vector<atom *>::iterator iter = selectedAtoms.begin(); iter != selectedAtoms.end(); ++iter) {
+    (*iter)->setPosition(RotationAxis.rotateVector((*iter)->getPosition(), alpha));
+  }
+  DoLog(0) && (Log() << Verbose(0) << "done." << endl);
+  return Action::state_ptr(new AtomRotateAroundOriginByAngleState(World::getInstance().getSelectedAtoms(), Axis, alpha));
+}
+
+Action::state_ptr AtomRotateAroundOriginByAngleAction::performUndo(Action::state_ptr _state) {
+  AtomRotateAroundOriginByAngleState *state = assert_cast<AtomRotateAroundOriginByAngleState*>(_state.get());
+
+  // Creation Line that is the rotation axis
+  Line RotationAxis(Vector(0.,0.,0.), state->Axis);
+
+  for (std::vector<atom *>::iterator iter = state->selectedAtoms.begin(); iter != state->selectedAtoms.end(); ++iter) {
+    (*iter)->setPosition(RotationAxis.rotateVector((*iter)->getPosition(), -state->alpha));
+  }
+
+  return Action::state_ptr(_state);
+}
+
+Action::state_ptr AtomRotateAroundOriginByAngleAction::performRedo(Action::state_ptr _state){
+  AtomRotateAroundOriginByAngleState *state = assert_cast<AtomRotateAroundOriginByAngleState*>(_state.get());
+
+  // Creation Line that is the rotation axis
+  Line RotationAxis(Vector(0.,0.,0.), state->Axis);
+
+  for (std::vector<atom *>::iterator iter = state->selectedAtoms.begin(); iter != state->selectedAtoms.end(); ++iter) {
+    (*iter)->setPosition(RotationAxis.rotateVector((*iter)->getPosition(), state->alpha));
+  }
+
+  return Action::state_ptr(_state);
+}
+
+bool AtomRotateAroundOriginByAngleAction::canUndo() {
+  return true;
+}
+
+bool AtomRotateAroundOriginByAngleAction::shouldUndo() {
+  return true;
+}
+
+const string AtomRotateAroundOriginByAngleAction::getName() {
+  return NAME;
+}
Index: src/Actions/AtomAction/RotateAroundOriginByAngleAction.hpp
===================================================================
--- src/Actions/AtomAction/RotateAroundOriginByAngleAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Actions/AtomAction/RotateAroundOriginByAngleAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,39 @@
+/*
+ * RotateAroundOriginByAngleAction.hpp
+ *
+ *  Created on: Aug 06, 2010
+ *      Author: heber
+ */
+
+#ifndef ROTATEAROUNDORIGINBYANGLEACTION_HPP
+#define ROTATEAROUNDORIGINBYANGLEACTION_HPP
+
+#include "Actions/Action.hpp"
+
+class Vector;
+
+void AtomRotateOrigin(Vector &Axis);
+
+class AtomRotateAroundOriginByAngleAction : public Action {
+  friend void AtomRotateAroundOriginByAngle(const Vector &Axis, double angle);
+
+public:
+  AtomRotateAroundOriginByAngleAction();
+  virtual ~AtomRotateAroundOriginByAngleAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *dialog);
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+
+#endif // ROTATEAROUNDORIGINBYANGLEACTION_HPP
Index: src/Actions/AtomAction/TranslateAction.cpp
===================================================================
--- src/Actions/AtomAction/TranslateAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Actions/AtomAction/TranslateAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,129 @@
+/*
+ * TranslateAction.cpp
+ *
+ *  Created on: May 10, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "Actions/AtomAction/TranslateAction.hpp"
+#include "Actions/ActionRegistry.hpp"
+#include "Helpers/Log.hpp"
+#include "atom.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "Helpers/Verbose.hpp"
+#include "World.hpp"
+
+#include <iostream>
+#include <fstream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/ValueStorage.hpp"
+
+/****** AtomTranslateAction *****/
+
+// memento to remember the state when undoing
+
+class AtomTranslateState : public ActionState {
+public:
+  AtomTranslateState(const std::vector<atom*> &_selectedAtoms, const Vector &_v, const bool _periodic) :
+    selectedAtoms(_selectedAtoms),
+    v(_v),
+    periodic(_periodic)
+  {}
+  std::vector<atom*> selectedAtoms;
+  Vector v;
+  bool periodic;
+};
+
+const char AtomTranslateAction::NAME[] = "translate-atoms";
+
+AtomTranslateAction::AtomTranslateAction() :
+  Action(NAME)
+{}
+
+AtomTranslateAction::~AtomTranslateAction()
+{}
+
+void AtomTranslate(Vector &x, bool periodic = false) {
+  ValueStorage::getInstance().setCurrentValue(AtomTranslateAction::NAME, x);
+  ValueStorage::getInstance().setCurrentValue("periodic", periodic);
+  ActionRegistry::getInstance().getActionByName(AtomTranslateAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* AtomTranslateAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryVector(NAME, false, ValueStorage::getInstance().getDescription(NAME));
+  dialog->queryBoolean("periodic", ValueStorage::getInstance().getDescription("periodic"));
+
+  return dialog;
+}
+
+Action::state_ptr AtomTranslateAction::performCall() {
+  Vector v;
+  bool periodic = false;
+  Box &domain = World::getInstance().getDomain();
+  std::vector<atom *> selectedAtoms = World::getInstance().getSelectedAtoms();
+
+  ValueStorage::getInstance().queryCurrentValue(NAME, v);
+  if (!ValueStorage::getInstance().queryCurrentValue("periodic", periodic, true))
+    periodic = false;
+
+  // TODO: use AtomSet::translate
+  for (std::vector<atom *>::iterator iter = selectedAtoms.begin(); iter != selectedAtoms.end(); ++iter) {
+    *(*iter) += v;
+    if (periodic)
+      (*iter)->setPosition(domain.WrapPeriodically((*iter)->getPosition()));
+  }
+
+  return Action::state_ptr(new AtomTranslateState(selectedAtoms, v, periodic));
+}
+
+Action::state_ptr AtomTranslateAction::performUndo(Action::state_ptr _state) {
+  AtomTranslateState *state = assert_cast<AtomTranslateState*>(_state.get());
+  Box &domain = World::getInstance().getDomain();
+
+  for (std::vector<atom *>::iterator iter = state->selectedAtoms.begin(); iter != state->selectedAtoms.end(); ++iter) {
+    *(*iter) -= state->v;
+    if (state->periodic)
+      (*iter)->setPosition(domain.WrapPeriodically((*iter)->getPosition()));
+  }
+
+  return Action::state_ptr(_state);
+}
+
+Action::state_ptr AtomTranslateAction::performRedo(Action::state_ptr _state){
+  AtomTranslateState *state = assert_cast<AtomTranslateState*>(_state.get());
+  Box &domain = World::getInstance().getDomain();
+
+  for (std::vector<atom *>::iterator iter = state->selectedAtoms.begin(); iter != state->selectedAtoms.end(); ++iter) {
+    *(*iter) += state->v;
+    if (state->periodic)
+      (*iter)->setPosition(domain.WrapPeriodically((*iter)->getPosition()));
+  }
+
+  return Action::state_ptr(_state);
+}
+
+bool AtomTranslateAction::canUndo() {
+  return true;
+}
+
+bool AtomTranslateAction::shouldUndo() {
+  return true;
+}
+
+const string AtomTranslateAction::getName() {
+  return NAME;
+}
Index: src/Actions/AtomAction/TranslateAction.hpp
===================================================================
--- src/Actions/AtomAction/TranslateAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Actions/AtomAction/TranslateAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,38 @@
+/*
+ * TranslateAction.hpp
+ *
+ *  Created on: May 10, 2010
+ *      Author: heber
+ */
+
+#ifndef TRANSLATEACTION_HPP
+#define TRANSLATEACTION_HPP
+
+#include "Actions/Action.hpp"
+#include "LinearAlgebra/Vector.hpp"
+
+void AtomTranslate(Vector &x, bool periodic);
+
+class AtomTranslateAction : public Action {
+  friend void AtomTranslate(Vector &x, bool periodic);
+
+public:
+  AtomTranslateAction();
+  virtual ~AtomTranslateAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *dialog);
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+
+#endif // TRANSLATEACTION_HPP
Index: src/Actions/AtomsCalculation.hpp
===================================================================
--- src/Actions/AtomsCalculation.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/AtomsCalculation.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -11,4 +11,6 @@
 #include "Actions/Calculation.hpp"
 
+class Dialog;
+
 template<typename T>
 class AtomsCalculation : public Calculation<std::vector<T> >
@@ -20,4 +22,5 @@
 protected:
   virtual std::vector<T>* doCalc();
+  virtual Dialog *fillDialog(Dialog *dialog);
 
 private:
Index: src/Actions/AtomsCalculation_impl.hpp
===================================================================
--- src/Actions/AtomsCalculation_impl.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/AtomsCalculation_impl.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -11,6 +11,4 @@
 #include "Actions/AtomsCalculation.hpp"
 #include "Actions/Calculation_impl.hpp"
-
-#include <iostream>
 
 using namespace std;
@@ -35,5 +33,9 @@
   Process::setMaxSteps(steps);
   Process::start();
-  for(World::AtomIterator iter=world->getAtomIter(descr);iter!=world->atomEnd();++iter){
+  for(World::internal_AtomIterator
+      iter=world->getAtomIter_internal(descr);
+      iter!=world->atomEnd_internal();
+      ++iter){
+
     Process::setCurrStep(iter.getCount());
     res->push_back(op(*iter));
@@ -43,4 +45,9 @@
 }
 
+template<typename T>
+Dialog *AtomsCalculation<T>::fillDialog(Dialog *dialog){
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+  return dialog;
+}
 
 #endif /* ATOMSCALCULATION_IMPL_HPP_ */
Index: src/Actions/CmdAction/BondLengthTableAction.cpp
===================================================================
--- src/Actions/CmdAction/BondLengthTableAction.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/CmdAction/BondLengthTableAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,11 +6,17 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "Actions/CmdAction/BondLengthTableAction.hpp"
+#include "Actions/ActionRegistry.hpp"
 #include "bondgraph.hpp"
 #include "config.hpp"
-#include "log.hpp"
-#include "verbose.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
 #include "World.hpp"
 
@@ -22,5 +28,5 @@
 #include "UIElements/UIFactory.hpp"
 #include "UIElements/Dialog.hpp"
-#include "Actions/MapOfActions.hpp"
+#include "Actions/ValueStorage.hpp"
 
 const char CommandLineBondLengthTableAction::NAME[] = "bond-table";
@@ -33,20 +39,24 @@
 {}
 
+void CommandBondLengthTable(std::string &BondGraphFileName) {
+  ValueStorage::getInstance().setCurrentValue(CommandLineBondLengthTableAction::NAME, BondGraphFileName);
+  ActionRegistry::getInstance().getActionByName(CommandLineBondLengthTableAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* CommandLineBondLengthTableAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryString(NAME, ValueStorage::getInstance().getDescription(NAME));
+
+  return dialog;
+}
+
 Action::state_ptr CommandLineBondLengthTableAction::performCall() {
   ostringstream usage;
   string BondGraphFileName;
-  Dialog *dialog = UIFactory::getInstance().makeDialog();
 
+  ValueStorage::getInstance().queryCurrentValue(NAME, BondGraphFileName);
+  DoLog(0) && (Log() << Verbose(0) << "Using " << BondGraphFileName << " as bond length table." << endl);
   config *configuration = World::getInstance().getConfig();
-  dialog->queryString(NAME, &BondGraphFileName, MapOfActions::getInstance().getDescription(NAME));
-
-  if(dialog->display()) {
-    DoLog(0) && (Log() << Verbose(0) << "Using " << BondGraphFileName << " as bond length table." << endl);
-    delete dialog;
-  } else {
-    delete dialog;
-    return Action::failure;
-  }
-
   if (configuration->BG == NULL) {
     configuration->BG = new BondGraph(configuration->GetIsAngstroem());
Index: src/Actions/CmdAction/BondLengthTableAction.hpp
===================================================================
--- src/Actions/CmdAction/BondLengthTableAction.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/CmdAction/BondLengthTableAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -11,5 +11,9 @@
 #include "Actions/Action.hpp"
 
+void CommandBondLengthTable(std::string &BondGraphFileName);
+
 class CommandLineBondLengthTableAction : public Action {
+  friend void CommandBondLengthTable(std::string &BondGraphFileName);
+
 public:
   CommandLineBondLengthTableAction();
@@ -20,4 +24,6 @@
 
   virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *dialog);
 private:
   virtual Action::state_ptr performCall();
Index: src/Actions/CmdAction/ElementDbAction.cpp
===================================================================
--- src/Actions/CmdAction/ElementDbAction.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/CmdAction/ElementDbAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,11 +6,17 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "Actions/CmdAction/ElementDbAction.hpp"
+#include "Actions/ActionRegistry.hpp"
 #include "config.hpp"
-#include "log.hpp"
+#include "Helpers/Log.hpp"
 #include "periodentafel.hpp"
-#include "verbose.hpp"
+#include "Helpers/Verbose.hpp"
 #include "World.hpp"
 
@@ -22,5 +28,5 @@
 #include "UIElements/UIFactory.hpp"
 #include "UIElements/Dialog.hpp"
-#include "Actions/MapOfActions.hpp"
+#include "Actions/ValueStorage.hpp"
 
 const char CommandLineElementDbAction::NAME[] = "element-db";
@@ -33,21 +39,26 @@
 {}
 
+void CommandElementDb(std::string &databasepath) {
+  ValueStorage::getInstance().setCurrentValue(CommandLineElementDbAction::NAME, databasepath);
+  ActionRegistry::getInstance().getActionByName(CommandLineElementDbAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* CommandLineElementDbAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryString(NAME, ValueStorage::getInstance().getDescription(NAME));
+
+  return dialog;
+}
+
 Action::state_ptr CommandLineElementDbAction::performCall() {
   ostringstream usage;
   string databasepath;
-  Dialog *dialog = UIFactory::getInstance().makeDialog();
 
   // get the path
   // TODO: Make databasepath a std::string
   config *configuration = World::getInstance().getConfig();
-  dialog->queryString(NAME, &databasepath, MapOfActions::getInstance().getDescription(NAME));
-
-  if(dialog->display()) {
-    strcpy(configuration->databasepath, databasepath.c_str());
-    delete dialog;
-  } else {
-    delete dialog;
-    return Action::failure;
-  }
+  ValueStorage::getInstance().queryCurrentValue(NAME, databasepath);
+  strcpy(configuration->databasepath, databasepath.c_str());
 
   // load table
Index: src/Actions/CmdAction/ElementDbAction.hpp
===================================================================
--- src/Actions/CmdAction/ElementDbAction.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/CmdAction/ElementDbAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -11,5 +11,9 @@
 #include "Actions/Action.hpp"
 
+void CommandElementDb(std::string &databasepath);
+
 class CommandLineElementDbAction : public Action {
+  friend void CommandElementDb(std::string &databasepath);
+
 public:
   CommandLineElementDbAction();
@@ -20,4 +24,6 @@
 
   virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *dialog);
 private:
   virtual Action::state_ptr performCall();
Index: src/Actions/CmdAction/FastParsingAction.cpp
===================================================================
--- src/Actions/CmdAction/FastParsingAction.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/CmdAction/FastParsingAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,10 +6,16 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "Actions/CmdAction/FastParsingAction.hpp"
+#include "Actions/ActionRegistry.hpp"
 #include "config.hpp"
-#include "log.hpp"
-#include "verbose.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
 #include "World.hpp"
 
@@ -21,5 +27,18 @@
 #include "UIElements/UIFactory.hpp"
 #include "UIElements/Dialog.hpp"
-#include "Actions/MapOfActions.hpp"
+#include "Actions/ValueStorage.hpp"
+
+// memento to remember the state when undoing
+
+class CommandLineFastParsingState : public ActionState {
+public:
+  CommandLineFastParsingState(const bool _oldvalue, const bool _newvalue) :
+    oldvalue(_oldvalue),
+    newvalue(_newvalue)
+  {}
+  bool oldvalue;
+  bool newvalue;
+};
+
 
 const char CommandLineFastParsingAction::NAME[] = "fastparsing";
@@ -32,43 +51,62 @@
 {}
 
+void CommandFastParsing(bool fastparsing) {
+  ValueStorage::getInstance().setCurrentValue(CommandLineFastParsingAction::NAME, fastparsing);
+  ActionRegistry::getInstance().getActionByName(CommandLineFastParsingAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* CommandLineFastParsingAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryBoolean(NAME, ValueStorage::getInstance().getDescription(NAME));
+
+  return dialog;
+}
+
 Action::state_ptr CommandLineFastParsingAction::performCall() {
-  Dialog *dialog = UIFactory::getInstance().makeDialog();
-
   config *configuration = World::getInstance().getConfig();
-  dialog->queryBoolean(NAME, &configuration->FastParsing, MapOfActions::getInstance().getDescription(NAME));
-
-  if(dialog->display()) {
-    if (configuration->FastParsing)
-      DoLog(0) && (Log() << Verbose(0) << "I won't parse trajectories." << endl);
-    else
-      DoLog(0) && (Log() << Verbose(0) << "I will parse trajectories." << endl);
-    delete dialog;
-    return Action::success;
-  } else {
-    delete dialog;
-    return Action::failure;
-  }
+  bool oldvalue = configuration->FastParsing;
+  bool newvalue;
+  ValueStorage::getInstance().queryCurrentValue(NAME, newvalue);
+  configuration->FastParsing = newvalue;
+  if (configuration->FastParsing)
+    DoLog(0) && (Log() << Verbose(0) << "I won't parse trajectories." << endl);
+  else
+    DoLog(0) && (Log() << Verbose(0) << "I will parse trajectories." << endl);
+  return Action::state_ptr(new CommandLineFastParsingState(oldvalue, newvalue));
 }
 
 Action::state_ptr CommandLineFastParsingAction::performUndo(Action::state_ptr _state) {
-//  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
+  CommandLineFastParsingState *state = assert_cast<CommandLineFastParsingState*>(_state.get());
 
-  return Action::failure;
-//  string newName = state->mol->getName();
-//  state->mol->setName(state->lastName);
-//
-//  return Action::state_ptr(new ParserLoadXyzState(state->mol,newName));
+  config *configuration = World::getInstance().getConfig();
+  configuration->FastParsing = state->oldvalue;
+  if (configuration->FastParsing)
+    DoLog(0) && (Log() << Verbose(0) << "I won't parse trajectories." << endl);
+  else
+    DoLog(0) && (Log() << Verbose(0) << "I will parse trajectories." << endl);
+
+  return Action::state_ptr(_state);
 }
 
 Action::state_ptr CommandLineFastParsingAction::performRedo(Action::state_ptr _state){
-  return Action::failure;
+  CommandLineFastParsingState *state = assert_cast<CommandLineFastParsingState*>(_state.get());
+
+  config *configuration = World::getInstance().getConfig();
+  configuration->FastParsing = state->newvalue;
+  if (configuration->FastParsing)
+    DoLog(0) && (Log() << Verbose(0) << "I won't parse trajectories." << endl);
+  else
+    DoLog(0) && (Log() << Verbose(0) << "I will parse trajectories." << endl);
+
+  return Action::state_ptr(_state);
 }
 
 bool CommandLineFastParsingAction::canUndo() {
-  return false;
+  return true;
 }
 
 bool CommandLineFastParsingAction::shouldUndo() {
-  return false;
+  return true;
 }
 
Index: src/Actions/CmdAction/FastParsingAction.hpp
===================================================================
--- src/Actions/CmdAction/FastParsingAction.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/CmdAction/FastParsingAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -11,5 +11,9 @@
 #include "Actions/Action.hpp"
 
+void CommandFastParsing(bool fastparsing);
+
 class CommandLineFastParsingAction : public Action {
+  friend void CommandFastParsing(bool fastparsing);
+
 public:
   CommandLineFastParsingAction();
@@ -20,4 +24,6 @@
 
   virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *dialog);
 private:
   virtual Action::state_ptr performCall();
Index: src/Actions/CmdAction/HelpAction.cpp
===================================================================
--- src/Actions/CmdAction/HelpAction.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/CmdAction/HelpAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,7 +6,13 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "Actions/CmdAction/HelpAction.hpp"
+#include "Actions/ActionRegistry.hpp"
 #include "CommandLineParser.hpp"
 
@@ -18,5 +24,5 @@
 #include "UIElements/UIFactory.hpp"
 #include "UIElements/Dialog.hpp"
-#include "Actions/MapOfActions.hpp"
+#include "Actions/ValueStorage.hpp"
 
 const char CommandLineHelpAction::NAME[] = "help";
@@ -29,36 +35,32 @@
 {}
 
-Action::state_ptr CommandLineHelpAction::performCall() {
+void CommandHelp() {
+  ActionRegistry::getInstance().getActionByName(CommandLineHelpAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* CommandLineHelpAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
   ostringstream usage;
-  Dialog *dialog = UIFactory::getInstance().makeDialog();
-
   usage << CommandLineParser::getInstance().visible << endl;
   dialog->queryEmpty(NAME, usage.str());
 
-  if(dialog->display()) {
-    delete dialog;
-    return Action::success;
-  } else {
-    delete dialog;
-    return Action::failure;
-  }
+  return dialog;
+}
+
+Action::state_ptr CommandLineHelpAction::performCall() {
+  return Action::success;
 }
 
 Action::state_ptr CommandLineHelpAction::performUndo(Action::state_ptr _state) {
-//  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
-
-  return Action::failure;
-//  string newName = state->mol->getName();
-//  state->mol->setName(state->lastName);
-//
-//  return Action::state_ptr(new ParserLoadXyzState(state->mol,newName));
+  return Action::success;
 }
 
 Action::state_ptr CommandLineHelpAction::performRedo(Action::state_ptr _state){
-  return Action::failure;
+  return Action::success;
 }
 
 bool CommandLineHelpAction::canUndo() {
-  return false;
+  return true;
 }
 
Index: src/Actions/CmdAction/HelpAction.hpp
===================================================================
--- src/Actions/CmdAction/HelpAction.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/CmdAction/HelpAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -11,5 +11,9 @@
 #include "Actions/Action.hpp"
 
+void CommandHelp();
+
 class CommandLineHelpAction : public Action {
+  friend void CommandHelp();
+
 public:
   CommandLineHelpAction();
@@ -20,4 +24,6 @@
 
   virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *dialog);
 private:
   virtual Action::state_ptr performCall();
